//      __ __    __  __      ____      __  __                
//     / // /   / / / /___  / / /_____/ / / /___  _________ 
//    / // /   / /_/ // _ \/ / // ___/ /_/ // _ \/ ___/ __ \ 
//   / // /   / __  //  __/ / /(__  ) __  //  __/ /  / /_/ / 
//  /_//_/   /_/ /_/ \___/_/_//____/_/ /_/ \___/_/   \____/
//

//version 1
//made it

//prefs
//$pref::warn::level (1 2)
//$pref::warn::times (2 3 4 5 6 7 8 9 10)
//$pref::warn::ban (0 1, if 1 ban not kick)
//$pref::warn::bantime (in min)

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	
	RTB_registerPref("Kick/Ban","Warnings","pref::warn::ban","list Kick 0 Ban 1","Script_Warn",0,0,0);
	RTB_registerPref("Admin Requirement","Warnings","pref::warn::level","list Admin 0 SuperAdmin 1","Script_Warn",0,0,0);
	RTB_registerPref("Warn Times","Warnings","pref::warn::times","int 2 100","Script_Warn",3,0,0);
	RTB_registerPref("Ban Time","Warnings","pref::warn::bantime","int 0 3600","Script_Warn",30,0,0);
	RTB_registerPref("Display Warn Count on warn","Warnings","pref::warn::display","bool","Script_Warn",1,0,0);
}
else
{
	$pref::warn::level = 1;
	$pref::warn::times = 3;
	$pref::warn::ban = 0;
	$pref::warn::bantime = 30;
	$pref::warn::display = 1;
}

function serverCmdWarn(%client,%targetName,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n)
{
	if(!$pref::warn::level && !%client.isAdmin)
		return;
	if($pref::warn::level && !%client.isSuperAdmin)
		return;
	
	%target = findClientByName(%targetName);
	if(!isObject(%target))
		return messageClient(%client,'',"\c3" @ %targetName SPC "\c0does not exist!");
	if(%target == %client)
		return messageClient(%client,'',"Stop trying to warn yourself.");
	if(%target.isSuperAdmin)
		return messageClient(%client,'',"You cannot warn a Super Admin!");
	
	%target.warns++;
	%msg = stripTrailingSpaces(%a SPC %b SPC %c SPC %d SPC %e SPC %f SPC %g SPC %h SPC %i SPC %j SPC %k SPC %l SPC %m SPC %n);
	if(%target.warns >= $pref::warn::times)
	{
		if($pref::warn::ban)
		{
			messageAll('MsgAdminForce','\c3%1 \c0has been banned because of %2 warnings.', %target.getSimpleName(),$pref::warn::times);
			serverCmdBan(%client,id,%target.getBLID(),$pref::warn::bantime,%msg); //not entirely sure any other way to do it D:
		}
		else
		{
			messageAll('MsgAdminForce','\c3%1 \c0has been kicked because of %2 warnings.', %target.getSimpleName(),$pref::warn::times);
			%target.delete("Reason for kick:" SPC %msg);
		}
	}
	else
	{
		%extra = "\c0" @ (($pref::warn::display) ? "(" @ %target.warns SPC "of" SPC $pref::warn::times @ ")" : "");
		messageAllExcept(%target,'MsgAdminForce','\c3%1 \c0has been warned. Reason:\c3 %2 %3', %target.getSimpleName(),%msg,%extra);
		messageClient(%target,'MsgAdminForce','You have been warned. Reason:\c3 %1 %2',%msg,%extra);
	}
}